%define	srcname		MuseScore
%define	shortname	mscore
%define	shortver	%(echo %{version}|cut -d. -f1,2)

Summary:	Linux MusE Score Typesetter
Name:		musescore
Version:	4.3.2
Release:	1
# (Fedora) rtf2html is LGPLv2+
# paper4.png paper5.png are LGPLv3
# the rest is GPLv2
# Soundfont is MIT
# Fonts are OFL
License:	GPLv2+ and LGPLv2+ and LGPLv3 and CC-BY and MIT and OFL
Group:		Sound
Url:		https://musescore.org
Source0:	https://github.com/musescore/MuseScore/archive/refs/tags/v%{version}.tar.gz?/%{srcname}-%{version}.tar.gz
BuildRequires:	cmake >= 3.16.0
BuildRequires:	desktop-file-utils
# For big docs
BuildRequires:	doxygen
BuildRequires:	graphviz
BuildRequires:	gzip
BuildRequires:	perl(Pod::Usage)
BuildRequires:	qt5-linguist
BuildRequires:	qt5-tools
BuildRequires:	texlive-dvips
BuildRequires:	texlive-latex
BuildRequires:	lame-devel
# BuildRequires:	lib64qtsingleapplication-qt5-devel
BuildRequires:	pkgconfig(alsa) >= 1.0.0
BuildRequires:	pkgconfig(fluidsynth)
BuildRequires:	pkgconfig(freetype2) >= 2.5.2
BuildRequires:	pkgconfig(jack) >= 0.98.0
BuildRequires:	pkgconfig(libpulse)
BuildRequires:	pkgconfig(ogg) >= 1.3.0
BuildRequires:	pkgconfig(poppler)
BuildRequires:	pkgconfig(poppler-qt5)
BuildRequires:	pkgconfig(portaudio-2.0) >= 19
BuildRequires:	pkgconfig(Qt5Core) >= 5.15.5
BuildRequires:	pkgconfig(Qt5Concurrent)
BuildRequires:	pkgconfig(Qt5Designer)
BuildRequires:	pkgconfig(Qt5Gui)
BuildRequires:	pkgconfig(Qt5Help)
BuildRequires:	pkgconfig(Qt5Network)
BuildRequires:	pkgconfig(Qt5NetworkAuth)
BuildRequires:	pkgconfig(Qt5OpenGL)
BuildRequires:	pkgconfig(Qt5PrintSupport)
BuildRequires:	pkgconfig(Qt5Qml)
BuildRequires:	pkgconfig(Qt5QmlModels)
BuildRequires:	pkgconfig(Qt5Quick)
BuildRequires:	pkgconfig(Qt5QuickControls2)
BuildRequires:	pkgconfig(Qt5QuickTemplates2)
BuildRequires:	pkgconfig(Qt5QuickWidgets)
BuildRequires:	pkgconfig(Qt5Script)
BuildRequires:	pkgconfig(Qt5ScriptTools)
BuildRequires:	pkgconfig(Qt5Svg)
BuildRequires:	pkgconfig(Qt5Test)
BuildRequires:	pkgconfig(Qt5Widgets)
BuildRequires:	pkgconfig(Qt5X11Extras)
BuildRequires:	pkgconfig(Qt5Xml)
BuildRequires:	pkgconfig(Qt5XmlPatterns)
BuildRequires:	pkgconfig(sndfile) >= 1.0.25
BuildRequires:	pkgconfig(vorbis) >= 1.3.3
Requires:	qt5-qtquickcontrols2-qml
Requires:	%{name}-fonts = %{EVRD}
Requires:	soundfont2-default
%rename		mscore

%description
MuseScore stands for Linux MusE Score Typesetter.
It features:
  - WYSIWYG design, notes are entered on a "virtual note sheet".
  - TrueType font(s) for printing & display allows for high quality scaling to
    all sizes.
  - Unlimited number of staves.
  - Up to four voices per staff.
  - Easy & fast note entry with mouse, keyboard or MIDI.
  - Many editing functions.
  - MusicXML and Midi (SMF) import/export.
  - MuseData import.
  - Integrated sequencer and FluidSynth software synthesizer to play scores.
  - Print or create pdf files.
  - Translated in 26 languages.

%files
%license LICENSE.*
%doc README.md doc/*.md
%{_bindir}/%{shortname}
%{_datadir}/%{shortname}-%{shortver}
%exclude %{_datadir}/%{shortname}-%{shortver}/manual/*
%{_datadir}/applications/org.%{name}.%{srcname}.desktop
%{_datadir}/metainfo/org.%{name}.%{srcname}.appdata.xml
%{_datadir}/mime/packages/%{name}.xml
%{_datadir}/soundfonts/FluidR3Mono_GM.sf3
%{_iconsdir}/hicolor/*/apps/%{shortname}.png
%{_iconsdir}/hicolor/*/mimetypes/*
%{_mandir}/man1/%{shortname}.1*
%{_mandir}/man1/%{name}.1*

#----------------------------------------------------------------------------

%package doc
Summary:	MuseScore documentation
License:	CC-BY
Group:		Development/Other
Requires:	%{name} = %{EVRD}
BuildArch:	noarch
%rename	mscore-doc

%description doc
MuseScore is a free cross platform WYSIWYG music notation program.
This package contains the user manual of MuseScore in different languages.

%files doc
%doc %{_datadir}/%{shortname}-%{shortver}/manual/*

#----------------------------------------------------------------------------

%package fonts
Summary:	MuseScore fonts
License:	GPLv2+ with exceptions and OFL
Group:		Publishing
BuildRequires:	fontforge
BuildRequires:	tetex
BuildRequires:	texlive-mf2pt1
BuildRequires:	texlive-metapost.bin
BuildRequires:	texlive-cm-lgc
BuildArch:	noarch
%rename	mscore-fonts

%description fonts
MuseScore is a free cross platform WYSIWYG music notation program.
This package contains the musical notation fonts for use of MuseScore.

%files fonts
%{_datadir}/fonts/%{shortname}/bravura/*
%{_datadir}/fonts/%{shortname}/campania/*
%{_datadir}/fonts/%{shortname}/edwin/*
%{_datadir}/fonts/%{shortname}/gootville/*
%{_datadir}/fonts/%{shortname}/leland/*
%{_datadir}/fonts/%{shortname}/musejazz/*
%{_datadir}/fonts/%{shortname}/petaluma/*
%{_datadir}/fonts/%{shortname}/*.ttf
%{_datadir}/fonts/%{shortname}/*.otf
%{_datadir}/fonts/%{shortname}/*.json
%{_datadir}/fonts/%{shortname}/*.xml

#----------------------------------------------------------------------------

%prep
%autosetup -p1 -n %{srcname}-%{version}

# Remove bundled stuff
rm -vrf thirdparty/singleapp
rm -vrf thirdparty/freetype
rm -vrf thirdparty/poppler

# (Fedora) Fix EOL encoding
sed 's|\r||' thirdparty/rtf2html/README > tmpfile
touch -r thirdparty/rtf2html/README tmpfile
mv -f tmpfile thirdparty/rtf2html/README

# Fix perms
find -name "*.cpp" -o -name "*.h" | xargs chmod 0644


%build
# There is already a directory named "build"
mkdir -p build.release
pushd build.release
# Otherwise the final mscore linking fails
export LDFLAGS="%{ldflags} -ldl"
	%cmake_qt5 ../.. -DCMAKE_BUILD_TYPE=RELEASE \
		-DMUSESCORE_BUILD_CONFIG=release \
		-DUSE_SYSTEM_FREETYPE="ON" \
		-DBUILD_JACK="ON" \
		-DBUILD_UNITY="OFF" \
		-DBUILD_CLOUD_MODULE="ON" \
		-DBUILD_CRASHPAD_CLIENT="OFF" \
		-DPACKAGE_FILE_ASSOCIATION="ON" \
		-DBUILD_UNIT_TESTS="OFF"

	%make lrelease
	%make manpages
	%make
popd



%install
pushd build.release
	%makeinstall_std -C build PREFIX=%{_prefix}
popd

# Install fonts
mkdir -p %{buildroot}%{_datadir}/fonts/%{shortname}
mkdir -p %{buildroot}%{_datadir}/fonts/%{shortname}/bravura
mkdir -p %{buildroot}%{_datadir}/fonts/%{shortname}/campania
mkdir -p %{buildroot}%{_datadir}/fonts/%{shortname}/edwin
mkdir -p %{buildroot}%{_datadir}/fonts/%{shortname}/gootville
mkdir -p %{buildroot}%{_datadir}/fonts/%{shortname}/leland
mkdir -p %{buildroot}%{_datadir}/fonts/%{shortname}/musejazz
mkdir -p %{buildroot}%{_datadir}/fonts/%{shortname}/petaluma
install -pm 644 fonts/*.ttf %{buildroot}%{_datadir}/fonts/%{shortname}
install -pm 644 fonts/*.xml %{buildroot}%{_datadir}/fonts/%{shortname}
install -pm 644 fonts/%{shortname}/*.ttf %{buildroot}%{_datadir}/fonts/%{shortname}
install -pm 644 fonts/%{shortname}/*.json %{buildroot}%{_datadir}/fonts/%{shortname}
install -pm 644 fonts/bravura/*.otf %{buildroot}%{_datadir}/fonts/%{shortname}
install -pm 644 fonts/bravura/*.json %{buildroot}%{_datadir}/fonts/%{shortname}/bravura
install -pm 644 fonts/campania/*.otf %{buildroot}%{_datadir}/fonts/%{shortname}/campania
install -pm 644 fonts/edwin/*.otf %{buildroot}%{_datadir}/fonts/%{shortname}/edwin
install -pm 644 fonts/gootville/*.otf %{buildroot}%{_datadir}/fonts/%{shortname}/gootville
install -pm 644 fonts/gootville/*.json %{buildroot}%{_datadir}/fonts/%{shortname}/gootville
install -pm 644 fonts/leland/*.otf %{buildroot}%{_datadir}/fonts/%{shortname}/leland
install -pm 644 fonts/leland/*.json %{buildroot}%{_datadir}/fonts/%{shortname}/leland
install -pm 644 fonts/musejazz/*.otf %{buildroot}%{_datadir}/fonts/%{shortname}/musejazz
install -pm 644 fonts/musejazz/*.json %{buildroot}%{_datadir}/fonts/%{shortname}/musejazz
install -pm 644 fonts/petaluma/*.otf %{buildroot}%{_datadir}/fonts/%{shortname}/petaluma
install -pm 644 fonts/petaluma/*.json %{buildroot}%{_datadir}/fonts/%{shortname}/petaluma

pushd  %{buildroot}%{_datadir}/fonts/%{shortname}
	cd bravura
	ln -s ../Bravura.otf .
	ln -s ../BravuraText.otf .
	cd ..
	ln -s campania/Campania.otf ./Campania.otf
	ln -s gootville/Gootville.otf ./Gootville.otf
	ln -s gootville/GootvilleText.otf ./GootvilleText.otf
	ln -s edwin/Edwin-BdIta.otf ./BdIta.otf
	ln -s edwin/Edwin-Bold.otf ./Edwin-Bold.otf
	ln -s edwin/Edwin-Italic.otf ./Edwin-Italic.otf
	ln -s edwin/Edwin-Roman.otf ./Edwin-Roman.otf
	ln -s leland/Leland.otf ./Leland.otf
	ln -s leland/LelandText.otf ./LelandText.otf
	ln -s musejazz/MuseJazz.otf ./MuseJazz.otf
	ln -s musejazz/MuseJazzText.otf ./MuseJazzText.otf
	ln -s petaluma/Petaluma.otf ./Petaluma.otf
	ln -s petaluma/PetalumaScript.otf ./PetalumaScript.otf
	ln -s petaluma/PetalumaText.otf ./PetalumaText.otf
popd

# Install soundfont
install -Dm 0644 -p share/sound/FluidR3Mono_GM.sf3 %{buildroot}%{_datadir}/soundfonts/FluidR3Mono_GM.sf3

# Install manual
mkdir -p %{buildroot}%{_datadir}/%{shortname}-%{shortver}/manual/plugins
install -m 0644 share/manual/reference-en.pdf %{buildroot}%{_datadir}/%{shortname}-%{shortver}/manual
install -m 0644 share/manual/plugins/manual.css %{buildroot}%{_datadir}/%{shortname}-%{shortver}/manual/plugins

# (Fedora) gather the doc files in one location...
cp -p thirdparty/rtf2html/ChangeLog ChangeLog.rtf2html
cp -p thirdparty/rtf2html/COPYING.LESSER COPYING.LESSER.rtf2html
cp -p thirdparty/rtf2html/README README.rtf2html
cp -p thirdparty/rtf2html/README.mscore README.mscore.rtf2html
cp -p thirdparty/rtf2html/README.ru README.ru.rtf2html
cp -p share/wallpapers/COPYRIGHT COPYING.wallpaper
cp -p fonts/bravura/OFL.txt COPYING.OFL
# ... and fix perms
chmod -x README.* COPYING.* ChangeLog.*

# Process .mcsz and .mcsx demo files
mkdir -p %{buildroot}%{_datadir}/%{shortname}-%{shortver}/demos
install -D -p share/templates/*.mscx %{buildroot}/%{_datadir}/%{shortname}-%{shortver}/demos/

# Install icons for mimetypes
for i in {16x16,24x24,32x32,48x48,64x64,96x96,128x128}; do
	mkdir -p %{buildroot}%{_iconsdir}/hicolor/$i/mimetypes/
	install -m 0644 share/icons/AppIcon/MS4_AppIcon_$i.png %{buildroot}%{_iconsdir}/hicolor/$i/mimetypes/application-x-%{shortname}.png
done

# Fix Desktop file
desktop-file-edit		--remove-key="Version" \
			--add-category="X-Notation" \
			--remove-category="Sequencer" --remove-category="Graphics" \
			--add-mime-type="audio/midi" --add-mime-type="text/x-lilypond" --add-mime-type="application/xml" \
			%{buildroot}/%{_datadir}/applications/org.%{name}.%{srcname}.desktop

# No point in packaging this stuff...
rm -rf	%{buildroot}%{_bindir}/crashpad_handler
rm -rf	%{buildroot}%{_includedir}/gmock
rm -rf	%{buildroot}%{_includedir}/gtest
rm -rf	%{buildroot}%{_includedir}/opus
rm -rf	%{buildroot}%{_libdir}/cmake/GTest
rm -rf	%{buildroot}%{_libdir}/*.a
rm -rf	%{buildroot}%{_libdir}/pkgconfig
# ... or headers for internal libraries
rm -rf	%{buildroot}%{_includedir}/kddockwidgets
rm -rf	%{buildroot}%{_libdir}/cmake/KDDockWidgets
